#/**********************************************************************************
#* Copyright (C) 2017-2020 by KEYARK, INC. - All Rights Reserved.
#* All information contained herein is proprietary and confidential to KEYARK, INC.
#* Any use, reproduction, or disclosure without the written
#* permission of KEYARK, INC. is prohibited.
#* Written by Natalia Belyaeva <nbelyaeva@keyark.com>
#***********************************************************************************/

import locale
locale.setlocale(locale.LC_ALL, 'en_US.utf-8')

class KeySqlConnectorBase:
    pem = ["-----BEGIN CERTIFICATE-----\n",
            "MIIDLzCCAhcCFCcDyr6f/Y8RgPil5L3UI+n6TUfvMA0GCSqGSIb3DQEBCwUAMFMx\n",
            "CzAJBgNVBAYTAkZSMQ0wCwYDVQQKDARrcmtyMSEwHwYDVQQLDBhEb21haW4gQ29u\n",
            "dHJvbCBWYWxpZGF0ZWQxEjAQBgNVBAMMCSoua3Jrci5pbzAgFw0yMDA2MTEyMjA1\n",
            "MjVaGA8yMTIwMDUxODIyMDUyNVowUzELMAkGA1UEBhMCRlIxDTALBgNVBAoMBGty\n",
            "a3IxITAfBgNVBAsMGERvbWFpbiBDb250cm9sIFZhbGlkYXRlZDESMBAGA1UEAwwJ\n",
            "Ki5rcmtyLmlvMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA6av3SotQ\n",
            "U5EwbIHGljgRbrSXLZRrWqnV8F4uEy5CBJEeUQk8TujFmHVk+VW1rSYt5BpasdnD\n",
            "mDqhFlMzu8wwCehg2EAm5s+dVbVmC7HrFVx4dDRV9TL3laccqmxSSdZmpKTabHp0\n",
            "7AbDozWLPtNGNZGnW3YlOLCg1pRXEMZZTBbiB72FzAnh7NMVgGVT4lEdZEhhSgLs\n",
            "OIbtUUCAZFBk+crRleNsbKKfCwOfvl/7luLBbvNn/Hqm2nHo7iaVtLFBIe4GXwcb\n",
            "Th3v5ZgZ4l8mvEVJ2j9BMqSwZLFzU0SV6fRvEvqxbjMCHze1XI6yoNfi6oFGrmhB\n",
            "piemFo76sGvw5QIDAQABMA0GCSqGSIb3DQEBCwUAA4IBAQAkOR+lNtTWBB43xewm\n",
            "R3tifbjjmlPZtPYS3LceJT4IM1Ia1gMz2LEnN0Za9hTP/nPf9Eyqry6uqJ1g/JhB\n",
            "KTR3X1BjG6uyEwdcNVOyMp3dEZUMhXoPfW75n/r113T/0gzznU9j7U0GHQU9eJkq\n",
            "sYD2roJg3Wb3Mg0hTHbuXg7imF0cW/NPpiR8ri14yM7jVsfE6FMMLM4gnDPsSomo\n",
            "aPN8cTlO+8yZibEZQIbdteoTx2ZqkKTbT8/Jzp4nRcgTTpIfBqh+Z0G5M5AKUi3E\n",
            "rSzBnSOcK5B58DPDC6O2aNXu2rnJsmcO1mTyACmkDYOi5gBqBkU0+mJCSxLU69g8\n",
            "bJEw\n",
              "-----END CERTIFICATE-----\n"]


    def __init__(self, host: str = "dummy_host", port:int = None, schema: str = ""):
        self._host = host
        self._port = port
        self._schema = schema
        self._connected = False

    def is_connected(self):
        """
        Check if there is connection with server
        :return: None
        """
        return self._connected

    def set_schema(self,schema : str = ""):
        self._schema = schema


if __name__ == "__main__":
    pass
