#/**********************************************************************************
#* Copyright (C) 2017-2020 by KEYARK, INC. - All Rights Reserved.
#* All information contained herein is proprietary and confidential to KEYARK, INC.
#* Any use, reproduction, or disclosure without the written
#* permission of KEYARK, INC. is prohibited.
#* Written by Natalia Belyaeva <nbelyaeva@keyark.com>
#***********************************************************************************/
import logging
from typing import List
from keysql_client.keysql_statement import KeySqlStatement

class KeySqlDataFileReader():
    """Read KeySql queries from file
    """
    _file_name = None

    def __init__(self, file_name: str) -> None:
        self._file_name = file_name

    def get_query_list_from_file(self): # , file_with_statement: str, *args, base_classes: List=[], keep_str_res=False, check_inj=False, format='keysql'):
        exec_line = ""
        query_list = []
        with open(self._file_name, 'r', encoding="utf-8") as ff:
            for line in ff:
                tmp_line = line.strip()
                if len(tmp_line) == 0:
                    continue
                exec_line += tmp_line
                if tmp_line.endswith(";"):
                    #print("exec_line: ", exec_line)
                    #self.execute(exec_line[:-1], keep_str_res=keep_str_res, format=format)
                    if len(exec_line[-1].strip()) > 0:
                        query_list.append(exec_line)
                    exec_line  = ""
                else:
                    exec_line += " "
            # in case of absent last ;
            if len(exec_line) != 0:
                #self.execute(exec_line, keep_str_res=keep_str_res, format=format)
                exec_line = exec_line.strip()
                if len(exec_line) > 0:
                    query_list.append(exec_line)

            return query_list

if __name__ == "__main__":

    keysql_data_file_reader = KeySqlDataFileReader('test_name')
    assert  keysql_data_file_reader._file_name == 'test_name'