#/**********************************************************************************
#* Copyright (C) 2017-2020 by KEYARK, INC. - All Rights Reserved.
#* All information contained herein is proprietary and confidential to KEYARK, INC.
#* Any use, reproduction, or disclosure without the written
#* permission of KEYARK, INC. is prohibited.
#* Written by Natalia Belyaeva <nbelyaeva@keyark.com>
#***********************************************************************************/
import logging
from typing import List
from keysql_client.keysql_statement import KeySqlStatement
from keysql_client.keysql_instance import KeySql_Instance

# TODO: not implemented in server code Not callable yet
class KeySqlDescribe(KeySqlStatement):
    """Revoke Statement
    String query equivalent:
    'revoke ... on schema <> from user <>'
    """

    def __init__(self) -> None:
        """
        :param no
        """
        #_describe_str = describe_str
        pass

    def create_request(self, reply: str) -> str:
        return reply

    def process_reply(self, reply: str, header=None) -> None:
        # nothing to process - input is ''

        if not reply or len(reply) == 0:
            return []

        # always len(reply = 1;   [{key:val}]
        res  =  []
        #print(reply, '========================================================================= xxx')
        #print(type(reply), type(reply[0]), "=================")
        ##print(reply[0], '================================process_reply')
        if type(reply[0]) is KeySql_Instance:
            val = reply[0].instance_value().strip().split('\n')
            #print(val, "=================================================xxx1 instance")
        else:
            for key in reply[0].keys():
                val = reply[0][key].strip().split('\n')
                #print(val, "=================================================xxx1 json")
        #print(val, "=================================================xxx1")
        res = [ss for ss in val if len(ss) > 0 and not ss.startswith('--')]
        return res

if __name__ == "__main__":
    grant_to_user = KeySqlDescribe('revoke all from user ttt')
