#/**********************************************************************************
#* Copyright (C) 2017-2020 by KEYARK, INC. - All Rights Reserved.
#* All information contained herein is proprietary and confidential to KEYARK, INC.
#* Any use, reproduction, or disclosure without the written
#* permission of KEYARK, INC. is prohibited.
#* Written by Natalia Belyaeva <nbelyaeva@keyark.com>
#***********************************************************************************/
import logging
from typing import List
from keysql_client.keysql_statement import KeySqlStatement
from keysql_client.keysql_mapper import KeySqlMapper
from keysql_client.keysql_parser import KeySqlParser


# TODO: not implemented in server code Not callable yet
class KeySqlGrantStatement(KeySqlStatement):
    """Grant Statement
    String query equivalent:
    'grant ... on schema <> to user <>'
    """

    def __init__(self)->  None: # , grant_str) -> None:
        """
        :param no
        """
        #_grant_str = grant_str
        pass

    def create_request(self, reply: str) -> str:
        return reply

    def process_reply(self, reply: str, header=None, base_classes:list = []) -> None:
        # nothing to process - input is ''
        #return reply
        logging.debug('reply before process:' + str(reply))
        instances = KeySqlParser.parse_select_reply(reply)

        logging.debug('--------->' + str(instances))

        results = []
        for instance in instances:
            if self._to_dict:
                curr = KeySqlMapper.keysql_inst_to_dict(instance)
            else:
                if len(base_classes) == 0:
                    curr = KeySqlMapper.keysql_inst_to_default_class_only(instance)
                else:
                    curr = KeySqlMapper.keysql_inst_to_class_inst(reply, base_classes)
            results.append(curr)

        return results


if __name__ == "__main__":

    grant_to_user = KeySqlGrantStatement('grant all to user ttt')
