#/**********************************************************************************
#* Copyright (C) 2017-2020 by KEYARK, INC. - All Rights Reserved.
#* All information contained herein is proprietary and confidential to KEYARK, INC.
#* Any use, reproduction, or disclosure without the written
#* permission of KEYARK, INC. is prohibited.
#* Written by Natalia Belyaeva <nbelyaeva@keyark.com>
#***********************************************************************************/

import logging
from keysql_client.keysql_instance import KeySql_Instance
import inspect
from typing import Dict, List

class KeySqlMapper(object):

    def __init__(self):
        pass

    @staticmethod
    def class_to_instance(class_inst) -> KeySql_Instance:
        #TODO
        pass

    @staticmethod
    def keysql_inst_to_dictionary_only(class_inst):

        if class_inst.__class__ == list:
            return list(map(KeySqlMapper.keysql_inst_to_dictionary_only, class_inst))
        if type(class_inst) == KeySql_Instance:
            res = class_inst.__dict__
            name = class_inst.instance_name()
            if name == 'RESULT':
                res = KeySqlMapper.keysql_inst_to_dictionary_only(res['_value'])
                return res
            #TODO
            # to uncomment if remove #BALL (example)
            if name[0] == '#':   # .startwith('#'):
                return KeySqlMapper.keysql_inst_to_dictionary_only(res['_value'])
                #return list(map(KeySqlMapper.keysql_inst_to_dictionary_only, res['_value']))

            return {name : KeySqlMapper.keysql_inst_to_dictionary_only(class_inst.__dict__['_value'])}

        if class_inst.__class__ == dict:
            if 'RESULT' in class_inst.keys():
                return class_inst['_value']
            if len(class_inst.keys()) == 1 and list(class_inst.keys())[0].startswith('#'):
                return KeySqlMapper.keysql_inst_to_dictionary_only(class_inst.values()[0])

            res = class_inst
            for key in res.keys():
                if key.startswith('#'):
                    return KeySqlMapper.keysql_inst_to_dictionary_only(res[key])
                if res[key].__class__ == KeySql_Instance:  #  dict:
                    res[key] = KeySqlMapper.keysql_inst_to_dictionary_only(res[key])

            return res
            #return list(map(KeySqlMapper.keysql_inst_to_dictionary_only, res['_value']))

        return class_inst



    @staticmethod
    def get_default_class_from_dict(dict_created, name, base_classes = []):

        #keys = list(dict_created.keys())
        # the only key
        #key = keys[0]
        return type(name, (), dict_created)

    @staticmethod
    def get_default_class_from_instance(instance,  base_classes = []):
        #keys = dict_created.keys()
        # the only key
        #key = instance['__name__']
        key = instance._name
        #res = type(key, (object,), instance['_value'])

        if type(instance._value) in [int, float, str] or instance._value is None:
            #simple_obj = KeySqlMapper.get_default_class_from_instance(class_inst)
            return instance._name

        if len(base_classes) == 0:
            res = type(key, (object,), instance._value)   #   res = type(key, (object,), instance)
        else:
            res = type(key, tuple(base_classes), instance._value)

        return res  #  type(key, (), instance['_value'])


    @staticmethod
    def keysql_inst_to_default_class_only(class_inst):

        if (not class_inst) or class_inst.__class__ in (dict, int, float, str):
            return class_inst  # class_inst._value

        if class_inst.__class__ == list:
            return list(map(KeySqlMapper.keysql_inst_to_default_class_only, class_inst))

        # logging.debug(class_inst.__name__ + ": type" + str(class_inst._value.__class__))
        assert class_inst.__class__ == KeySql_Instance
        #print(class_inst.__class__)
        assert class_inst._value.__class__ in (list, dict, int, float, str, type(None)) #  None -> <class 'NoneType'>

        r = {}
        r[class_inst._name] = class_inst._value
        return r

    @staticmethod
    def keysql_inst_to_value_or_default(class_inst):
        if class_inst.__class__ == KeySql_Instance:
            return class_inst._value
        return KeySqlMapper.keysql_inst_to_default_class_only(class_inst)

    @staticmethod
    def keysql_inst_to_dict_impl(class_inst,top):

        if class_inst.__class__ == list:
            r = {}
            for x in class_inst:
                r[class_inst._name] = KeySqlMapper.keysql_inst_to_dict_impl(x, True)   # False
            return r

        if not class_inst or class_inst.__class__ in (int, float, str):
            return class_inst  # class_inst._value

        if not hasattr(class_inst, '_value'):
            return class_inst

        tmp = hasattr(class_inst, '_value')
        if not tmp:
            print(class_inst, '----------------- class_inst -xxxx')
        tmp = hasattr(class_inst._value, '__class__')
        if not tmp:
            print(class_inst._value, '----------------- class_inst._value -xxxx')

        # TODO: get rd of ???
        if class_inst._value.__class__ == list:
            if class_inst._name == 'RESULT':
                r = {}
                for x in class_inst._value:
                    r[x._name] = KeySqlMapper.keysql_inst_to_dict_impl(x, False)
                return r
            else:
                r = []
                for x in class_inst._value:
                    r.append(KeySqlMapper.keysql_inst_to_dict_impl(x,False))
                return r

        if not class_inst._value or class_inst._value.__class__ in (int, float, str):
            return class_inst  # class_inst._value

        assert class_inst._value.__class__ == dict
        r = {}
        for key, value in class_inst._value.items():
            r[key] = KeySqlMapper.keysql_inst_to_dict_impl(value,False)
        if top:
            return {class_inst._name : r}
        return r

    @staticmethod
    def keysql_inst_to_dict(class_inst):
        return KeySqlMapper.keysql_inst_to_dict_impl(class_inst,True)

    @staticmethod
    def keysql_inst_to_default_class(class_inst):
        return KeySqlMapper.keysql_inst_to_default_class_only(class_inst)

    #@classmethod
    @staticmethod
    def keysql_inst_to_class_inst(class_inst, class_types:list=[]):
        logging.debug("in keysql_inst_to_class_inst: ", str(class_types))

        if type(class_inst) == list:
            res = []
            for item in class_inst:
                res.append(KeySqlMapper.keysql_inst_to_class_inst(item, class_types))
            return res
        #if hasattr(class_inst, '__name__') and class_inst['__name__'][0] == '#':
        #    res = KeySqlMapper.class_inst_to_dict(class_inst['__name__'])

        elif hasattr(class_inst, '__dict__'):
            res = class_inst.__dict__
            #print('keys:', res.keys)
            #print(class_inst.__repr__())
            for key in res.keys():
                #print('key:', key)
                #print(class_inst.__class__.__name__, '-------\n')
                if hasattr(res[key], '__dict__'):
                    class_inst[key] = KeySqlMapper.keysql_inst_to_class_inst(class_inst[key], class_types)

                elif type(res[key]) == list:
                    processed = res[key]
                    #for i in range(len(processed)):
                    #    processed[i] = KeySqlMapper.class_inst_to_dict(processed[i])
                    res = KeySqlMapper.keysql_inst_to_class_inst(res[key])
                    if key[0] != '#':
                        res = {key:res}
                    #res[key] = processed

                     #return res # #return class_inst
        else:
            res = [class_inst]
            #name = class_inst.__class__.__name__
            #return [{name: res}]
        #return [{name: res}]
        # result of different select and join
        if hasattr(class_inst, '__name__'):
            if res['__name__'] == 'RESULT':
                res = res['_value']
            # returns list of instansces
            elif res['__name__'] is not None and res['__name__'][0] == '#':
                res = res['_value']
        return res

    @staticmethod
    def from_json(data, cls):
        annotations: dict = cls.__annotations__ if hasattr(cls, '__annotations__') else None
        if issubclass(cls, List):
            list_type = cls.__args__[0]
            instance: list = list()
            for value in data:
                instance.append(KeySqlMapper.from_json(value, list_type))
            return instance
        elif issubclass(cls, Dict):
                key_type = cls.__args__[0]
                val_type = cls.__args__[1]
                instance: dict = dict()
                for key, value in data.items():
                    instance.update(KeySqlMapper.from_json(key, key_type), KeySqlMapper.from_json(value, val_type))
                return instance
        else:
            instance : cls = cls()
            for name, value in data.items():
                field_type = annotations.get(name)
                if inspect.isclass(field_type) and isinstance(value, (dict, tuple, list, set, frozenset)):
                    setattr(instance, name, KeySqlMapper.from_json(value, field_type))
                else:
                    setattr(instance, name, value)
            return instance


if __name__ == "__main__":

    from keysql_client.keysql_parser import KeySqlParser

    str1 = "{LAST_NAME:\'Johns\'}"
    test1 = KeySqlParser.parse_select_reply(str1)
    print(test1)
    print(type(test1))
    print(test1[0])
    assert type(test1[0]) == KeySql_Instance # # assert test1 == "['Johns']"
    res1 = KeySqlMapper.keysql_inst_to_default_class_only(test1)
    print(res1)
    print(dir(res1))

    str1 = "{STORE_INFO:{STORE_NAME:'XYZ_STORE',SCHEMA_NAME:'KEYSQLUSER',OWNER_NAME:'keysqluser',IS_EXTERNAL:0,HOSTS:{KEYOBJECT_DEFINITION:{COMPONENT_KEYOBJECT_NAMES:NULL,KEYOBJECT_NAME:'X_C',KEYOBJECT_TYPE:'CHAR'},KEYOBJECT_DEFINITION:{COMPONENT_KEYOBJECT_NAMES:{KEYOBJECT_NAME:'X_C',KEYOBJECT_NAME:'X_N'},KEYOBJECT_NAME:'X_CC',KEYOBJECT_TYPE:'COMPOSITION'},KEYOBJECT_DEFINITION:{COMPONENT_KEYOBJECT_NAMES:NULL,KEYOBJECT_NAME:'X_D',KEYOBJECT_TYPE:'DATE'},KEYOBJECT_DEFINITION:{COMPONENT_KEYOBJECT_NAMES:{KEYOBJECT_NAME:'X_C',KEYOBJECT_NAME:'X_I',KEYOBJECT_NAME:'X_N'},KEYOBJECT_NAME:'X_INC',KEYOBJECT_TYPE:'COMPOSITION'},KEYOBJECT_DEFINITION:{COMPONENT_KEYOBJECT_NAMES:NULL,KEYOBJECT_NAME:'X_N',KEYOBJECT_TYPE:'NUMBER'}},CONSTRAINTS:{CONSTRAINT:{CONSTRAINT_DEFINITION:'UNIQUE(X_N)',CONSTRAINT_NAME:'CST_15130659210253926483'},CONSTRAINT:{CONSTRAINT_DEFINITION:'CHECK(X_N <= ABS(X_N))',CONSTRAINT_NAME:'DEF_X_D'},CONSTRAINT:{CONSTRAINT_DEFINITION:'HOSTS(X_C,X_CC,X_D,X_INC,X_N)',CONSTRAINT_NAME:'HOSTS'}},CATALOG_NAME:'XYZ'}}"
    test1 = KeySqlParser.parse_select_reply(str1)
    res1 = KeySqlMapper.keysql_inst_to_default_class_only(test1)

    str1 = "{STORE_INFO:{STORE_NAME:'PEOPLE_STORE',SCHEMA_NAME:'TEST3',OWNER_NAME:'TEST3',IS_EXTERNAL:0,HOSTS:{KEYOBJECT_DEFINITION:{COMPONENT_KEYOBJECT_NAMES:{KEYOBJECT_NAME:'FIRST_NAME',KEYOBJECT_NAME:'LAST_NAME',KEYOBJECT_NAME:'YOB',KEYOBJECT_NAME:'EMAILS',KEYOBJECT_NAME:'ADDRESS'},KEYOBJECT_NAME:'PERSON',KEYOBJECT_TYPE:'COMPOSITION'}},CONSTRAINTS:NULL,CATALOG_NAME:'PEOPLE'}}"
    test1 = KeySqlParser.parse_select_reply(str1)
    res1 = KeySqlMapper.keysql_inst_to_default_class_only(test1)
    print(res1)

    str1 = "{EMAIL:{EMAIL_ADDRESS:\'shopping@johns.com\',EMAIL_TYPE:NULL}}"
    test1 = KeySqlParser.parse_select_reply(str1)
    print(test1[0])
    print(test1[0].instance_name())
    res1 = KeySqlMapper.keysql_inst_to_default_class_only(test1)
    print(res1)
    print(res1[0]["EMAIL"])
    print(res1[0]["EMAIL"]["EMAIL_ADDRESS"])

    str1 = "{x1:1},{x2:2}"
    test1 = KeySqlParser.parse_select_reply(str1)
    res1 = KeySqlMapper.keysql_inst_to_default_class_only(test1)
    print(res1)

    str1 = "{STORE_NAME:'store_1'},{STORE_NAME:'store_2'}"
    test1 = KeySqlParser.parse_select_reply(str1)
    res1 = KeySqlMapper.keysql_inst_to_value_or_default(test1[0])
    print(res1)
    res1 = KeySqlMapper.keysql_inst_to_value_or_default(test1[1])
    print(res1)

    str1 = "{EMAILS:{EMAIL:{EMAIL_ADDRESS:\'shopping@johns.com\',EMAIL_TYPE:NULL}},FIRST_NAME:NULL,LAST_NAME:\'Johns\',YOB:1999}"
    str2 = "{PERSON:{EMAILS:{EMAIL:{EMAIL_ADDRESS:\'shopping@johns.com\',EMAIL_TYPE:NULL}},FIRST_NAME:NULL,LAST_NAME:\'Johns\',YOB:1999}}"

    """
    small_example = "{BallPack: {Brand: 'Carambo', Name: 'Standard_Carom' , UPC: 123456789012, BallSet: { Style:'carom', Diam_mm: 61.5, Qty: 3, Balls: { Ball:{ Num: Null, Color:'red'},Ball:{ Num: Null, Color:'white'},}}}}"

    print(small_example)

    small_example = small_example.replace(' ', '')
    print(small_example)

    res = small_example.split('}')
    res = [item + '}' for item in res]
    for item in res:
        print(item)


    print({'a':'b'})
    print({'a':{'b':[{'c':'d'}, {'e':'f'}]}})

    o =  AllMyFields({'a': 1, 'b': 2})
    print(o.a, o.b)
    print(o)


    ball_1 = Ball(None, 'red')
    ball_2 = Ball(None, 'white')
    ball_3 = Ball(None, 'white_spot')

    #all_1.alias('ball_1')

    print('\nball:')
    print(ball_1.__dict__)
    print(vars(ball_1))
    for elem in vars(ball_1):
        print(elem, type(elem))

    print(ball_2)
    print(ball_3)
    balls = [ball_1, ball_2, ball_3]

    #print('\nballs:')
    #print(vars(balls))

    ballset = BallSet('carom', 61.5, 3, balls)

    print('\nballset:')
    print(dir(ballset))
    print(vars(ballset))

    print('\nballset.__dict__:')
    print(ballset.__dict__)
    print(ballset.__dict__['balls'][0])    # [0].__dict__)
    print(ballset.__dict__['balls'][0])    # [0].__dict__)
    print(type(ballset.__dict__['balls'][0]))

    print(type(ballset.__dict__['balls'][0].__dict__))
    print(ballset.__dict__['balls'][0].__dict__)

    ballset_to_dict = KeySqlMapper.class_inst_to_dict(ballset)

    print(ballset_to_dict)


    print('-'*40)

    for elem in vars(ballset):
        print(elem, type(elem))

    # if hasattr(a, 'property'):
    #     a.property

    dict_a = {'BallPack': {'Brand': 'Carambo', 'Name': 'Standard_Carom' , 'UPC': 123456789012,
     'BallSet': { 'Style':'carom', 'Diam_mm': 61.5, 'Qty': 3,
                   'Balls':  [{'Ball':{ 'Num': 'Null', 'Color':'red'}},
                               {'Ball':{ 'Num': 'Null', 'Color':'white'}},
                                {'Ball':{ 'Num': 'Null', 'Color':'white_spot'}}]
     	   	      }
           }
}
    map_class = AllMyFields(dict_a)

    #from bunch import bunchify

    print(vars(map_class))

    print(map_class)

    print('-'*40)
    d = {'a': 1, 'b': {'c': 2}, 'd': ["hi", {'foo': "bar"}]}
    #x.update(d)

    from collections import namedtuple

    d_named = namedtuple('Struct', dict_a.keys())(*dict_a.values())
    print(d_named)

    """
