#/**********************************************************************************
#* Copyright (C) 2017-2020 by KEYARK, INC. - All Rights Reserved.
#* All information contained herein is proprietary and confidential to KEYARK, INC.
#* Any use, reproduction, or disclosure without the written
#* permission of KEYARK, INC. is prohibited.
#* Written by Natalia Belyaeva <nbelyaeva@keyark.com>
#***********************************************************************************/
import logging
from typing import List
from keysql_client.keysql_statement import KeySqlStatement
from keysql_client.keysql_mapper import KeySqlMapper
from keysql_client.keysql_parser import KeySqlParser

# TODO: not implemented in server code Not callable yet
class KeySqlShowUsersStatement(KeySqlStatement):
    """Show Users Statement
    String query equivalent:
    'show users'
    """

    def __init__(self) -> List[str]:
        """
        :param no
        """
        pass

    def create_request(self) -> str:
        return 'show users'

    def process_reply(self, reply: str,  header=None, base_classes:list = []) -> List:
        """
        all_items_names = reply.strip()
        if all_items_names == '':
            return []
        all_items_names = all_items_names.split(',\n')
        return all_items_names
        """

        logging.debug('users_satement: reply before process:' + str(reply))
        instances = KeySqlParser.parse_select_reply(reply)
        logging.debug('--------->' + str(instances))

        results = []
        for instance in instances:
            if self._to_dict:
                curr = KeySqlMapper.keysql_inst_to_dict(instance)
            else:
                if len(base_classes) == 0:
                    curr = KeySqlMapper.keysql_inst_to_default_class_only(instance)
                else:
                    curr = KeySqlMapper.keysql_inst_to_class_inst(reply, base_classes)
            results.append(curr)

        return results



if __name__ == "__main__":

    show_schemas = KeySqlShowUsersStatement()
